/*
; copystring.c
;
; Demonstracny program v jazyku C pre kopirovanie ASCII retazcov
; do vnutornej RAM
; Dlzka retazca kontrolovana koncovym znakom 00H (v jazyku C
; dodany automaticky vzdy na konci retazca)
;
;
; Opis:
;
; Program postupne kopiruje tri rozne retazce do internej (DATA) ram:
; ASCII retazec AS1 je ulozeny v externej (XDATA) pamati dat,
; ASCII retazec AS2 je ulozeny v pamati programu (CODE),
; ASCII retazec AS3 je ulozeny v internej pamati dat
;
; retazce sa skopiruju do buffra AD vo vnutornej RAM.
;
; Autor:        M.Drutarovsky, TU Kosice
; Date:         24.10.2003
; Verzia:       1.0
; Poslena oprava: 2007-10-23, M.D.
*/


#if (0)     // niekedy je vyhodnejsie pouzit podmienenu kompilaciu meisto /*
v programe je vyuzivana funkcia

char *strcpy (
  char *dst,    /* destination string */
  char *src);   /* source string */

prototyp je v <string.h>

Na zobrazenie informacii o kniznicnych funkciach je mozne vyuzit Help sytem
prostredia uVison (klavesnica F1)
#endif

#include <string.h>

// definicie retazcov v roznych pamatiach 8051

xdata volatile char AS1[]= "12345678";     //"PRVY RETAZEC"; retazec v externej pamati dat (XDATA)
code char AS2[] = "DRUHY RETAZEC";         // retazec v pamati programu (CODE)
data char AS3[] = "TRETI RETAZEC";         // retazec v internej pameti dat (SMALL model)

/*
ak premenna nema specifikovane umiestnenie, pozuije sa preddefinovane umiestnenie
dane pouzitym pamatovym modelom
Project-> Options-> Target-> Memory model   (SMALL, COMPACT, LARGE)
*/

char AD [20];                              // CIELOVA ADRESA BLOKU DAT (interna pamet)

//----------------------------------------------
// HLAVNY PROGRAM
//----------------------------------------------

void main (void)
{

 strcpy(AD,AS1);                           // kopirovanie z externej pamete

 strcpy(AD,AS2);                           // kopirovanie z pamete programu

 strcpy(AD,AS3);                           // kopirovanie z internej pamete

 while(1);                                 // nekonecna slucka
}







